var upnode = require('upnode');
var light = require('lightswitch');

module.exports.createServer = function (port) {
    var self = this;

    this.switch = function (name, value) { 
        light.switch(name, value);
        return this;
    };

    this.flip = function (name) {
        light.switches[name].flip();
        return this;
    };

    this.is_off = function (name, cb) {
        cb(light.switches[name].is_off());
    };

    this.is_on = function (name, cb) {
        cb(light.switches[name].is_on());
    };

    this.get = function (name, cb) {
        cb(light.switches[name]);
    };

    upnode(function (client, conn) {
        console.log(client);
        console.log(conn);
        return self;
    }).listen(port);

};

module.exports.connect = function (port) {
    var up = upnode.connect(port);
    var self = {};
    self.up = up;
    self.close = up.close;

    // this pattern was taken from seaport written by @substack
    // https://github.com/substack/seaport/blob/master/index.js#L37-47
    ['switch', 'flip', 'is_on', 'is_off', 'get']
    .forEach(function (name) {
        self[name] = function () {
            var args = [].slice.call(arguments);
            up(function (remote) {
                remote[name].apply(null, args);
            });
        };
    });
    
    return self;
};
